#ifndef GL_ES
#	define precision
#	define lowp
#	define mediump
#	define highp
#else
precision highp float;
#endif

uniform lowp sampler2D texture0;
uniform highp vec2 Ring;
uniform highp vec2 EmmiterPos;

varying highp vec2 raster_pos;
varying lowp vec4 frag_color;

void main()
{
	highp float x = sqrt (raster_pos.x * raster_pos.x + raster_pos.y * raster_pos.y);
	lowp float alpha = clamp ((-abs (x - Ring.x) + (Ring.y - Ring.x))/1.5, 0.0, 1.0);

	gl_FragColor = frag_color;
	gl_FragColor.a *= alpha;
}
