#ifndef GL_ES
#	define precision
#	define lowp
#	define mediump
#	define highp
#else
precision highp float;
#endif

attribute vec2      in_position;
attribute vec2      in_uv0;
attribute lowp vec4 in_color;

uniform vec4 ViewTransform;
uniform highp vec2 EmmiterPos;

varying highp	vec2 raster_pos;
varying lowp	vec4 frag_color;

void main()
{
	frag_color = in_color;

	highp vec4 pos = vec4( ViewTransform.x * in_position.x + ViewTransform.y, 
	                  ViewTransform.z * in_position.y + ViewTransform.w, 
	                  0.0, 1.0 );
	raster_pos = in_position.xy - EmmiterPos;

	gl_Position = pos;
}