#ifndef GL_ES
#	define precision
#	define lowp
#	define mediump
#	define highp
#else
precision mediump float;
#endif

uniform lowp sampler2D Texture0;
uniform lowp sampler2D Texture1;

uniform      float glow_center;
uniform      float glyph_center;
uniform lowp vec4  back_color;
uniform      float stepSize;

varying      vec2 out_uv0;
varying      vec2 out_uv1;
varying lowp vec4 out_color;

void main(void)
{
    lowp vec4  color = texture2D(Texture1, out_uv1);
    lowp float dist  = color.a;
    float width = stepSize;
    lowp float alpha = smoothstep(glyph_center-width, glyph_center+width, dist);
    lowp vec3  rgb = mix(out_color.rgb, back_color.rgb, alpha);
    lowp float mu = smoothstep(glyph_center, glow_center, sqrt(dist));
    
    lowp vec4  glow = vec4(rgb, max(alpha,mu));
    lowp vec4  diffuse = texture2D( Texture0, out_uv0 );
    
    gl_FragColor = diffuse + glow * ( 1.0 - step(0.15,diffuse.a) );
}