#ifndef GL_ES
#	define precision
#	define lowp
#	define mediump
#	define highp
#else
precision mediump float;
#endif

uniform   mediump vec2           center;
// A squared radius, actually
uniform   mediump float          radius;


varying   lowp vec4      out_color;
varying   vec2           out_uv0;


void main()
{
	mediump vec2  pos = out_uv0 - center;
	mediump float r2   = radius;
	mediump float dist = dot(pos,pos);
	
	lowp float alpha = smoothstep(0.0, r2, dist);
	
	gl_FragColor = vec4(out_color.rgb, out_color.a * alpha);
}