#ifndef GL_ES
#	define precision
#	define lowp
#	define mediump
#	define highp
#else
precision mediump float;
#endif

uniform   lowp sampler2D texture0;
uniform highp float Phase;
uniform highp float Scale;
uniform highp float Fade;

varying        vec2      out_uv0;
varying highp vec2	point;
varying   lowp vec4      out_color;

void main()
{
	highp float R = sqrt (point.x * point.x + point.y * point.y);
	highp float val = max (cos (sqrt (R) * Scale - Phase) * Fade, 0.0);
	if (val > 0.0)
		val = 1.0;

	gl_FragColor = texture2D( texture0, out_uv0 );
	gl_FragColor.a *= val;
}
