#ifndef GL_ES
#	define precision
#	define lowp
#	define mediump
#	define highp
#else
precision highp float;
#endif

attribute vec2      in_position;
attribute vec2      in_uv0;
attribute lowp vec4 in_color;

uniform   vec4      ViewTransform;
uniform highp float Phase;
uniform highp float Scale;
uniform highp float Fade;

varying   vec2      out_uv0;
varying highp vec2	point;

void main()
{
	out_uv0 	= in_uv0;
	point		= vec2 (in_color.r, in_color.g);  

	gl_Position = vec4( ViewTransform.x * in_position.x + ViewTransform.y, 
	                    ViewTransform.z * in_position.y + ViewTransform.w, 
	                    0.0, 1.0 );
}