--module (..., package.seeall)

anim.base = {}

function anim.base.run_callback(animation, callback_id, ...)
	local cb = animation[callback_id]

	if not cb then return end

	if type(cb) == 'table' then
		for i,v in ipairs(cb) do
			v(animation,...)
		end
	else
		cb(animation,...)
	end
end

function anim.base.add_callback(animation, callback_id, callback)
	local prev = animation[callback_id]
	if type(prev) == 'table' then
		table.insert(prev, callback)
	else
		if prev then
			animation[callback_id] = { prev, callback }
		else
			animation[callback_id] = { callback }
		end
	end
end

function anim.base.set_property_value(animation, value)
	local prop = animation.property
	local obj  = animation.object

	if type(prop) == 'string' then
		obj[prop] = value
	else
		prop(obj, value)
	end
end

return anim.base