--module (..., package.builder)

require "anim/base.lua"
local base = anim.base

local function empty_update() end

local function update(self, dt)
	if not self.started then
		self.started = true
		self.animation:start()
	end

	if self.animation:isFinished() then
		self.update = empty_update
		base.run_callback(self, "on_finished")
	else
		self.animation:update(dt)
	end
end

local function id(x) return x end

local function build(context)
	local map = context.map
	local time = assert(context.time or context.duration)

	if not map and context.easing then
		map = function(x) return context.easing(x, time) end
	end

	return {
		id   = context.id,

		animation = context.animation,

		started = false,

		on_finished = context.on_finished,

		update = update,
		reset = function(self)
			self.t = 0
			self.update = update
		end
	}
end


anim.cpp_anim = build

return build