--module (..., package.builder)

require "anim/base.lua"
local base = anim.base

local function empty_update() end

local function update(self, dt)
	self.current_time = self.current_time + dt

	if self.current_time >= self.time then
		self.update = empty_update
		base.run_callback(self, "on_finished")
	end
end

local function build(context)
	local anim =  {
		id   = context.id,
		time = assert(context.time),
		current_time = 0,
		on_finished = context.on_finished,
		update = update,
		reset = function(self)
			self.current_time = 0
			self.update = update
		end
	}

	return anim
end

anim.delay = build

return delay