require "anim/base.lua"

local base = anim.base
local tinsert, tremove = table.insert, table.remove

local function push (self, anim)
	tinsert (self.q, anim)
	base.add_callback (anim, "on_finished", function() self:pop() end)
end 

local function pop (self)
	assert (#self.q > 0)
	tremove (self.q, 1)
end

local function update (self, dt)
	local anim = self.q[1]
	if anim then anim:update (dt) end
end

local function empty (self)
	return #self.q == 0 
end

local function build()
	return { q = { }, push = push, pop = pop, update = update, empty = empty }
end

anim.queue = build