ios = ios or {}
ios.inapp = {}
ios.inapp.cache = {}

local cache_path = "/home/billing/cache"

local ios_cache = ios.inapp.cache

function ios_cache.load()
	if file.exists( cache_path ) then
		ios_cache.state = dofile( cache_path )
		print( "Store cache is loaded. ".. #ios_cache.state .. " items")
	else
		print( "Loading empty store cache")
		ios_cache.state = {}
	end
end

function ios_cache.save()
	if not ios_cache.state then return end

	local data = table.dump( ios_cache.state )

	file.write_string( cache_path, data)
end

function ios_cache.add_tx( product_id, receipt )
	if not ios_cache.state[ product_id ] then
		ios_cache.state[ product_id ] = { receipt }
	else
		table.insert( ios_cache.state[ product_id ], receipt)
	end

	ios_cache.save()
end

function ios_cache.tx_checked( product_id )
	if ios_cache.state[ product_id ] then
		table.remove( ios_cache.state[ product_id ], 1 )
		if #ios_cache.state[ product_id ] == 0 then
			ios_cache.state[ product_id ] = nil
		end

		ios_cache.save()
	end
end

function ios_cache.has_pending_tx()
	return next( ios_cache.state ) and true or false
end

function ios_cache.get_next_tx()
	local p_id, p_val = next( ios_cache.state )
	if not p_id then
		return nil
	end

	return p_id, p_val[1]
end

ios_cache.load()