
-- Engine entry point

require "application_settings.lua"
require "updater.lua"

local TEST_UI     = DEBUG and false
-- view, is_modal
local TEST_SCREEN = function()
	require "ui/modal/server_error.lua"
	local v = ui.server_error.create (true)
	v.delegate_builder (
	{
		finished = function (v)
			ui.core.view_controller:close_modal_view (v)
		end
	}).build (v)
	return v, true
end

local function run_game()
	--get_sound_pool():play ("ambient/SFX_Atmos_01.wav")
	local sound_fx_enabled = underworld2.settings:get ("sound_fx_enabled", true)
	if not sound_fx_enabled then
		get_sound_pool():mute()
	end

	-- force location provider initialization, workaround for iOS to 
	-- ask user permissions before location is actually may be needed
	net.location_provider()

	require "ui/core/view_controller.lua"
	require "ui/core/view.lua"

	underworld2.ui = { }

	if not TEST_UI then
		require "login.lua"
	else
		ui.widgets = ui.widgets or {}
		local view,m = TEST_SCREEN()

		if m then
			local w = ui.Widget()
			w:setOrigin (0, 0)
			w:setSize (1, 1)

			do
				local img = ui.Picture()
				img:setTexture (bundle.resources.wallpapers.login)
				
				local original_size = img:getPreferredSize()
				
				local scale = 1.0 / original_size.x
				local size = math.vec2 (1.0, original_size.y * scale)

				img:setPlacingMode (ui.Picture_PlacingModeStretch)
				img:setSize (size)
				img:setOrigin (0, 0)
				w:addChild (img)
			end

			ui.core.view_controller.instance:setRootView (ui.WidgetView(w))

			ui.core.view_controller:show_modal_view (view)
		else
			ui.core.view_controller.instance:setRootView (view)
		end
	end
end

if not run_updater (run_game) then
	run_game()
end
