require "network/online_controller.lua"

local controller = setmetatable ({ }, { __index = network.online_controller } )


local function __push_back (request)
	underworld2.network.push_back (request)
end

function controller.create()
	return setmetatable ({ }, { __index = controller })
end

function controller:send (request, async)
	if not async then ui.event_view.show() end

	__push_back 
	{
		url = request.url,
		body = request.body,
		on_completed = function (result)
			if not async then ui.event_view.close() end
			if request.on_completed then request.on_completed (result) end
		end,
		on_server_error = function (error)
			if not async then ui.event_view.close() end
			
			if request.on_server_error then 
				return request.on_server_error (error) 
			else
				return false
			end
		end
	}
end

network.game_online_controller = controller
