network = network or {}

local concat, insert = table.concat, table.insert
local tostring = tostring

--[[
	network.mailto {
		to = email address or array of email addresses,
		[cc = = email address or array of email addresses],
		[bcc = = email address or array of email addresses],
		[subject = subject],
		[body = body]
	}	
	url encoding will be performed by the function
]]

function network.mailto( params )
	if not params.to then
		error("TO parameter is not provided to mailto")
	end

	local email_string = "mailto:"

	if type(params.to) == 'table' then
		email_string = email_string .. concat(params.to, ",")
	else
		email_string = email_string .. tostring(params.to)
	end

	local url_params = {}

	if params.cc then
		if type(params.cc) == 'table' then
			table.insert(url_params, "cc="..concat(params.cc, ","))
		else
			table.insert(url_params, "cc="..params.cc)
		end
	end

	if params.bcc then
		if type(params.bcc) == 'table' then
			table.insert(url_params, "bcc="..concat(params.bcc, ","))
		else
			table.insert(url_params, "bcc="..params.bcc)
		end
	end

	if params.subject then 
		table.insert(url_params, "subject="..crypto.url_encode(params.subject))
	end

	if params.body then
		table.insert(url_params, "body="..crypto.url_encode(params.body))
	end

	if #url_params > 0 then
		email_string = email_string .. "?" .. concat(url_params, "&")
	end

	os.device:openURL( email_string )
end