local controller = { }

controller.default = controller

function controller:send (request, async) error "Default online controller implementation was not set up." end

function controller.set_default (instance)
	self.default = instance
end

function controller.send (request, async)
	controller.default:send (request, async)
end

function controller.send_async (request)
	controller.default:send (request, true)
end

function controller.send_sync (request)
	controller.default:send (request, false)
end

function controller.child_for_name (table, name, recursive)
	if not table.children then return end
	
	for i, v in pairs (table.children) do
		if v.name == name then
			return v
		elseif recursive then
			return xml_get_child_for_name (v, name, true)
		end
	end
end

network.online_controller = controller
