local xep_0045 = 
{
	number 	= "XEP-0045",
	name	= "proto.xep_0045",
	alias 	= "muc",
}

local j

function xep_0045.init (jabber)
	j = jabber
end

function xep_0045.send (jid, text, user_data)
	local payload = user_data or { }
	table.insert (payload, { 
			name = "body",
			children = { { text = text } }
		})

	j.send (
	{
		name = "message",
		ns = "jabber:client",
		type = "groupchat",
		to = jid,
		children = payload
	})
end

function xep_0045.join (jid, handler)
	j.send (
	{
		name 	= "presence",
		to 		= jid,
		children = { { name = "x", xmlns = "http://jabber.org/protocol/muc" } }
	}, handler)
end

function xep_0045.leave (jid)
	j.send (
	{
		name = "presence",
		to = string.format ("%s/%s", jid, j.username),
		type = "unavailable",
	})
end

return xep_0045