local xep_0082 = 
{
	number 	= "XEP-0082",
	name	= "proto.xep_0082",
	alias	= "date_time"
}

local j

function xep_0082.init (jabber)
	j = jabber
end

function xep_0082.time (datestr)
	local t = { year = 0, month = 0, day = 0, hour = 0, min = 0, sec = 0, isdst = 0 }
	
	local first, last, YYYY, MM, DD, timestr = string.find (datestr, "(%d%d%d%d)%-(%d%d)%-(%d%d)(.*)")
	
	if not first or not last then
		return 0
	end

	t.year = tonumber (YYYY)
	t.month = tonumber (MM)
	t.day = tonumber (DD)

	if #timestr > 0 then
		local _, _, hh, mm, ss, TZD = string.find (timestr, "T(%d%d):(%d%d):(%d%d)(.*)")

		t.hour = tonumber (hh)
		t.min = tonumber (mm)
		t.sec = tonumber (ss)

		-- TODO: TZD
	end

	local ts = os.time (t) - os.time ({year=1970, month=1, day=1, hour=0})
	return ts -- local timezone
end

function xep_0082.delay_stamp()
	local str = os.date ("!%Y-%m-%dT%H:%M:%SZ", os.time())
	return str
end

return xep_0082