
local window = nil
local busted_modal = nil

local bust_params =
{
	commodity_id 	= 1,
	amount 			= 0,
	cash 			= 0,
	location 		= "London",
	courier_tag 	= 1,
	is_purchasing	= false,
	payoff_price	= 0,
}

-- courier that talks
local courier1_tag = 2
-- courier that was busted
local courier2_tag = 1


local stages =
{
	--[01]
	function (t)
		local c = underworld2.couriers
		courier1_tag = courier1_tag == tutorial.bust_params.courier_tag and courier2_tag or courier1_tag
		courier2_tag = tutorial.bust_params.courier_tag

		ui.preloadTexture ("ui/tutorial/tutorial_finger_ill:filtered")
		ui.preloadTexture (c.image_large[courier1_tag])
		ui.preloadTexture (c.image_large[courier2_tag])
		ui.preloadTexture ("ui/modal_wide_window:filtered")
		ui.preloadTexture ("ui/backlight_modal_large:filtered")

		local view = t:create_brief_view (c.names[courier1_tag], L ("KEY_TUTORIAL_BUST_01", c.names[courier2_tag]), c.image_large[courier1_tag])
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message1"
	end,
	--[02]
	function (t)
		local c = underworld2.couriers
		local view = t:create_brief_view (c.names[courier1_tag], L ("KEY_TUTORIAL_BUST_02"), c.image_large[courier1_tag])
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message2"
	end,
	--[03]
	function (t)
		local view = t:create_brief_police_view (L ("KEY_DETECTIVE"), L ("KEY_TUTORIAL_BUST_03"), "ui/characters/ch_cop_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message3"
	end,
	--[04]
	function (t)
		local view = t:create_brief_police_view (L ("KEY_DETECTIVE"), L ("KEY_TUTORIAL_BUST_04"), "ui/characters/ch_cop_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message4"
	end,
	--[05]
	function (t)
		local bust_params = tutorial.bust_params
		underworld2.player:addGold (bust_params.payoff_price)
		window = ui.core.view.builder (setmetatable ({
			build_ui = function()
				return ui.Widget()
			end
			}, { __index = ui.core.window })).build()

		busted_modal = ui.busted_modal.create (bust_params, false, L ("KEY_TUTORIAL_BUST_05"))
		window:add_subview (busted_modal)
		ui.core.view_controller:show_modal_view (window)

		busted_modal.delegate_builder (
		{
			finished = function (v)
				get_sound_pool():play ("ui/SFX_Premium_Purchase.wav")
				t:next_stage()
			end
		}).build (busted_modal)

		busted_modal:disable()
		underworld2.timed_events:queue (underworld2.server_time() + 1.0, function() 
			busted_modal:enable()
			ui.core.view_controller.instance:resetTouchEventFilter()
			t:next_stage() 
		end)

		return nil, "show_busted_modal"
	end,
	--[06]
	function (t)
		local btn = busted_modal.ui.bribe_button
		ui.core.view_controller.instance:setTouchEventFilter (btn:mapToRoot (btn:getOrigin()), btn:getSize())
		local pos = btn:mapToRoot (btn:getOrigin()) + btn:getSize() * 0.5
		local finger = underworld2.tutorial:create_tap_view (pos, 0)
		window:add_subview (finger)
		return function()
			ui.core.view_controller.instance:resetTouchEventFilter()
			window:remove_subview (finger)
			window:remove_subview (busted_modal)
			ui.core.view_controller:close_modal_view (window)
			window = nil
			busted_modal = nil
		end, "bribe"
	end,
	--[07]
	function (t)
		ui.event_view.show()
		underworld2.network.push_back
		{
			url = "/api/payOff.do",
			body = 
			{
				name = "request",
				type = "gold",
				children = 
				{
					{ name = "cost", text = tutorial.bust_params.payoff_price },
				}
			},
			on_completed = function()
				ui.event_view.close()

				local c = underworld2.couriers
				local view = t:create_brief_view (c.names[courier2_tag], L ("KEY_TUTORIAL_BUST_07"), c.image_large[courier2_tag])
				ui.core.view.delegate_builder (
				{
					finished = function (self)
						ui.core.view_controller:close_modal_view (self)
						t:next_stage()
					end
				}).build (view)

				ui.core.view_controller:show_modal_view (view)
			end
		}

		
		return function()
			local c = underworld2.couriers
			ui.removeTextureFromPreloadList ("ui/tutorial/tutorial_finger_ill:filtered")
			ui.removeTextureFromPreloadList (c.image_large[courier1_tag])
			ui.removeTextureFromPreloadList (c.image_large[courier2_tag])
			ui.removeTextureFromPreloadList ("ui/modal_wide_window:filtered")
			ui.removeTextureFromPreloadList ("ui/backlight_modal_large:filtered")
		end, "message5"
	end,

}

tutorial.bust = stages
tutorial.bust_params = bust_params
