local finger = nil

local stages = 
{
	-- [01]
	function (t)
		ui.preloadTexture ("ui/characters/ch_advisor_modal:filtered")
		ui.preloadTexture ("ui/tutorial/tutorial_finger_ill:filtered")
		ui.preloadTexture ("ui/modal_wide_window:filtered")

		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_HEAT_01"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message1"
	end,

	-- [02]
	function (t)
		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_HEAT_02"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message2"
	end,

	-- [03]
	function (t)
		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_HEAT_03"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				--t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message3"
	end,

	-- [04]
	function (t)
		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_HEAT_04"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message4"
	end,

	-- [05] Okay, you made a good deal and took some heat. Cutting another deal right away could be risky
	function (t)

		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_HEAT_05"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message5"
	end,

	-- [06] Everybody has a price, even cops. Throw some cash, drop the Heat to make 'em look the other way
	function (t)
		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_HEAT_06"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message6"
	end,

	-- [07] Action: tap-finger is pointing at "-" button at the Heat Bar
	function (t)
		local btn = underworld2.ui.status_panel.police_exposure_controller.ui.heat_drop
		ui.core.view_controller.instance:setTouchEventFilter (btn:mapToRoot (btn:getOrigin()), btn:getSize())
		local pos = btn:mapToRoot (btn:getOrigin()) + btn:getSize() * 0.5
		local finger = underworld2.tutorial:create_tap_view (pos, math.pi * 0.25)
		underworld2.ui.window:add_subview (finger)

		assert (underworld2.ui.status_panel.heat_drop_conn_id ~= nil)

		events.disconnect (btn:getClickedSignalProxy(), underworld2.ui.status_panel.heat_drop_conn_id)
		-- fwd
		local conn_id 
		conn_id = events.connect (btn:getClickedSignalProxy(), function()
			ui.core.view_controller.instance:setTouchEventFilter (math.vec2 (0, 0), math.vec2 (0, 0))
			underworld2.ui.window:remove_subview (finger)
			events.disconnect (btn:getClickedSignalProxy(), conn_id)

			t:next_stage()
		end)

		return nil, "tap_lower_hit"
	end,

	-- [08] Show heat_modal
	function (t)
			
		window = ui.core.view.builder (setmetatable ({
			build_ui = function()
				return ui.Widget()
			end
		}, { __index = ui.core.window })).build()

		get_sound_pool():play ("ui/SFX_Busted_Loop.wav")
		
		heat_modal = ui.core.view.builder (ui.heat_modal).build()
		heat_modal.delegate_builder (
		{
			finished = function (self)
				window:remove_subview (self)
				if finger then
					window:remove_subview (finger)
					finger = nil
				end
				ui.core.view_controller.instance:resetTouchEventFilter()

				if self.result == ui.heat_modal.RESULT_RESET then
					local player = underworld2.player
					local exposure = player:getPoliceExposure()
					local price = exposure:getResetPrice (underworld2.server_time())
					
					if price <= player:getGold() then
						get_sound_pool():play ("ui/SFX_Heat_Drop.wav")
						underworld2.network.reset_heat (price, function() end)
						player:removeGold (price)
						player:resetHeat()
					else
						--get_sound_pool():play ("ui/SFX_Cash_Out.wav")
						--ui.not_enough_gold.show(price - underworld2.player:getGold())
					end
				end
				
				ui.core.view_controller:close_modal_view (window)
				window = nil
				heat_modal = nil
				t:next_stage()
			end
		}).build (heat_modal)
		window:add_subview (heat_modal)

		ui.core.view_controller:show_modal_view (window)

		ui.core.view_controller.instance:setTouchEventFilter (math.vec2 (0, 0), math.vec2 (0, 0))

		underworld2.timed_events:queue (underworld2.server_time() + 0.5, function() t:next_stage() end)

		return nil, "show_heat_modal"
	end,

	-- [09] Action: tap-finger is pointing at the "Bribe cops" button
	function (t)
		local btn = heat_modal.ui.payoff
		ui.core.view_controller.instance:setTouchEventFilter (btn:mapToRoot (btn:getOrigin()), btn:getSize())
		local pos = btn:mapToRoot (btn:getOrigin()) + btn:getSize() * 0.5
		finger = underworld2.tutorial:create_tap_view (pos, math.pi)
		window:add_subview (finger)
		
		local conn_id 
		conn_id = events.connect (btn:getClickedSignalProxy(), function()
			ui.core.view_controller.instance:resetTouchEventFilter()
			if finger then
				window:remove_subview (finger)
				finger = nil
			end
			events.disconnect (btn:getClickedSignalProxy(), conn_id)
		end)

		return nil, "bribe_cops"
	end,

	-- [10] Nice. A bribe a day keeps the DEA away. And you don't wanna mess with those. They'll go nuclear on your biz if they're in a bad mood
	function (t)
		-- return default connection...
		local btn = underworld2.ui.status_panel.police_exposure_controller.ui.heat_drop
		underworld2.ui.status_panel.heat_drop_conn_id = events.connect (btn:getClickedSignalProxy(), ui.heat_modal.show)

		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_HEAT_10"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.removeTextureFromPreloadList ("ui/characters/ch_advisor_modal:filtered")
				ui.removeTextureFromPreloadList ("ui/tutorial/tutorial_finger_ill:filtered")
				ui.removeTextureFromPreloadList ("ui/modal_wide_window:filtered")

				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message7"
	end
}

tutorial.heat = stages
