require "underworld2/tutorial.lua"
require "network/tutorial_online_controller.lua"

local _shops = 
{
	{
		owner_id = -1,
		id = 1,

		count = 20,
		sell_price = 10,

		max_purchase_count = 0,
		purchase_price = 0,
		
		duration = 5,
	},
	{
		owner_id = -2,
		id = 1,

		count = 16,
		sell_price = 12,

		max_purchase_count = 2,
		purchase_price = 20,
		
		duration = 3 * 60,
	},
	{
		owner_id = -3,
		id = 1,

		count = 46,
		sell_price = 13,

		max_purchase_count = 0,
		purchase_price = 0,
		
		duration = 5 * 60,
	},
	
	{
		owner_id = -4,
		id = 1,

		count = 20,
		sell_price = 15,

		max_purchase_count = 0,
		purchase_price = 0,
		
		duration = 2 * 60,
	},

	{
		owner_id = -5,
		id = 1,

		count = 37,
		sell_price = 19,

		max_purchase_count = 0,
		purchase_price = 0,
		
		duration = 5 * 60,
	},

	{
		owner_id = -6,
		id = 1,

		count = 0,
		sell_price = 0,

		max_purchase_count = 23,
		purchase_price = 27,
		
		duration = 20,
	},

	{
		owner_id = -7,
		id = 1,

		count = 0,
		sell_price = 0,

		max_purchase_count = 52,
		purchase_price = 25,
		
		duration = 3 * 60,
	},

	{
		owner_id = -8,
		id = 1,

		count = 0,
		sell_price = 0,

		max_purchase_count = 21,
		purchase_price = 19,
		
		duration = 3 * 60,
	},

	{
		owner_id = -9,
		id = 1,

		count = 0,
		sell_price = 0,

		max_purchase_count = 56,
		purchase_price = 10,
		
		duration = 30,
	},

	{
		owner_id = -9,
		id = 2,

		count = 26,
		sell_price = 31,

		max_purchase_count = 0,
		purchase_price = 0,
		
		duration = 60,
	},

	{
		owner_id = -10,
		id = 2,

		count = 22,
		sell_price = 35,

		max_purchase_count = 0,
		purchase_price = 0,
		
		duration = 2 * 60,
	},

	{
		owner_id = -11,
		id = 2,

		count = 30,
		sell_price = 36,

		max_purchase_count = 0,
		purchase_price = 0,
		
		duration = 5 * 60,
	},

	{
		owner_id = -3,
		id = 2,

		count = 12,
		sell_price = 38,

		max_purchase_count = 0,
		purchase_price = 0,
		
		duration = 8 * 60,
	},

	{
		owner_id = -12,
		id = 2,

		count = 60,
		sell_price = 40,

		max_purchase_count = 0,
		purchase_price = 0,
		
		duration = 3 * 60,
	},
}

local _owners =
{
	[-1] = {
		id = -1,
		nickname = L "KEY_TUTORIAL_INITIAL_NAME_1", 
		avatar_url = "http://uw2.avatars.s3.amazonaws.com/30.png",
		tile_offset = math.vec2d (0, 0),
	},
	[-2] = {
		id = -2,
		nickname = L "KEY_TUTORIAL_INITIAL_NAME_2", 
		avatar_url = "http://uw2.avatars.s3.amazonaws.com/38.png",
		tile_offset = math.vec2d (0, 0),
	},
	[-3] = {
		id = -3,
		nickname = L "KEY_TUTORIAL_INITIAL_NAME_3", 
		avatar_url = "http://uw2.avatars.s3.amazonaws.com/31.png",
		tile_offset = math.vec2d (0, 0),
	},
	[-4] = {
		id = -4,
		nickname = L "KEY_TUTORIAL_INITIAL_NAME_4", 
		avatar_url = "http://uw2.avatars.s3.amazonaws.com/28.png",
		tile_offset = math.vec2d (0, 0),
	},
	[-5] = {
		id = -5,
		nickname = L "KEY_TUTORIAL_INITIAL_NAME_5", 
		avatar_url = "http://uw2.avatars.s3.amazonaws.com/11.png",
		tile_offset = math.vec2d (0, 0),
	},
	[-6] = {
		id = -6,
		nickname = L "KEY_TUTORIAL_INITIAL_NAME_6", 
		avatar_url = "http://uw2.avatars.s3.amazonaws.com/71.png",
		tile_offset = math.vec2d (0, 0),
	},
	[-7] = {
		id = -7,
		nickname = L "KEY_TUTORIAL_INITIAL_NAME_7", 
		avatar_url = "http://uw2.avatars.s3.amazonaws.com/18.png",
		tile_offset = math.vec2d (0, 0),
	},
	[-8] = {
		id = -8,
		nickname = L "KEY_TUTORIAL_INITIAL_NAME_8", 
		avatar_url = "http://uw2.avatars.s3.amazonaws.com/14.png",
		tile_offset = math.vec2d (0, 0),
	},
	[-9] = {
		id = -9,
		nickname = L "KEY_TUTORIAL_INITIAL_NAME_9", 
		avatar_url = "http://uw2.avatars.s3.amazonaws.com/33.png",
		tile_offset = math.vec2d (0, 0),
	},
	[-10] = {
		id = -10,
		nickname = L "KEY_TUTORIAL_INITIAL_NAME_10", 
		avatar_url = "http://uw2.avatars.s3.amazonaws.com/5.png",
		tile_offset = math.vec2d (0, 0),
	},

	[-11] = {
		id = -11,
		nickname = L "KEY_TUTORIAL_INITIAL_NAME_11", 
		avatar_url = "http://uw2.avatars.s3.amazonaws.com/55.png",
		tile_offset = math.vec2d (0, 0),
	},
	[-12] = {
		id = -12,
		nickname = L "KEY_TUTORIAL_INITIAL_NAME_12", 
		avatar_url = "http://uw2.avatars.s3.amazonaws.com/50.png",
		tile_offset = math.vec2d (0, 0),
	}
}

local function _create_npc (owner)
	
	local tile_offset = owner.tile_offset

	local tile_info = underworld2.player:getTileInfo()
	local zoom = math.pow (2, tile_info:getZoom())
	
	local npc_tile = math.vec2d (0, 0)
	npc_tile.x = (tile_info:getTileIndex().x + math.random_value (1, 100) / 100 + tile_offset.x) / zoom
	npc_tile.y = (tile_info:getTileIndex().y + math.random_value (1, 100) / 100 + tile_offset.y) / zoom
	
	local pos = math.geopoint_from_plane (npc_tile)

	local profile = underworld2.Profile (owner.id, false)
	profile:setNickname (owner.nickname)
	profile:setAvatarUrl (owner.avatar_url)
	profile:setLocation (pos)
	
	profile_ptr = underworld2.ProfilePtr (runtime.disown (profile))
	underworld2.ProfileDatabase():add (profile_ptr)
	return profile_ptr
end 

local function _create_shop (items, owner)
	local shops = underworld2.Shops()
	local index = shops:add (items.id, owner:id())
	index:setIsPlayer (false)
	index:setLocation (owner:getLocation())
	index:setDuration (items.duration)
	index:setSellingAmount (items.count)
	index:setSellingPrice (items.sell_price)
	index:setPurchaseAmount (items.max_purchase_count)
	index:setPurchasePrice (items.purchase_price)
	index:commit()
	--return { items = items, tax = 0.0, protection_coefficient = 1.0, owner = { id = owner:id(), is_player = owner:isPlayer(), geo_point = { lon = owner:getGeoPoint().x, lat = owner:getGeoPoint().y } } }
end

local _shop_cache

local levelup_view

--fwd, on tutorial start will contain some parameters that will be restored on the tutorial end
local player_state_cache = { }

local default_online_controller

local stages = 
{
	--[1] "Hey Ace! So you want to dig in the big biz, huh? Think you know everything there's to know, right? Time's money, so let the enlightenment begin!"
	function (t)

		default_online_controller = network.online_controller.default
		network.online_controller.default = network.tutorial_online_controller.create()

		underworld2.Shops():clear()

		ui.preloadTexture ("ui/characters/ch_advisor_modal:filtered")
		ui.preloadTexture ("ui/characters/ch_runner_modal_1:filtered")
		ui.preloadTexture ("ui/tutorial/tutorial_finger_ill:filtered")
		ui.preloadTexture ("ui/modal_wide_window:filtered")

		for i, v in ipairs (_shops) do
			local owner_id = v.owner_id
			_create_shop (v, _create_npc (_owners[owner_id]))
			underworld2.ShopsNetwork():add (owner_id)
		end

		underworld2.ShopsNetwork():update()

		player_state_cache.cash = underworld2.player:getMoney()
		player_state_cache.gold = underworld2.player:getGold()
		player_state_cache.rp = underworld2.player:getRespectPoints()
		player_state_cache.level_id = underworld2.player:getLevel()

		local player = underworld2.player
		local item = player:getEquipedItem (1)
		if item:get() then 
			player:addMoney (item:getPrice())
			player:removeItem (item:getId())
		end

		underworld2.player:setLevel (1)
		underworld2.player:setRespectPoints (0)
		underworld2.player:addGold (9)
		underworld2.player:removeMoney(_shops[6].purchase_price * _shops[6].max_purchase_count - _shops[1].sell_price * _shops[6].max_purchase_count)

		underworld2.ui.status_panel:disable()
		underworld2.ui.main_view:lock_map_move()
		underworld2.ui.main_view:show_map (false)

		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_01"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message1"
	end,

	--[2] tap finger is pointing to Home button(open trade card at commodity 2 in buying mode)
	function (t)
		underworld2.ui.main_view:set_current_item (2)

		local btn = underworld2.ui.main_view.ui.btn_market
		ui.core.view_controller.instance:setTouchEventFilter (btn:mapToRoot (btn:getOrigin()), btn:getSize())
		local pos = btn:mapToRoot (btn:getOrigin()) + btn:getSize() * 0.5
		local finger = underworld2.tutorial:create_tap_view (pos, math.pi)
		local conn_id 
		conn_id = events.connect (btn:getClickedSignalProxy(), function()
			ui.core.view_controller.instance:setTouchEventFilter(math.vec2 (0, 0), math.vec2 (0, 0))
			underworld2.ui.main_view:lock_trade_gesture()
			underworld2.ui.window:remove_subview (finger)
			finger:finalize()
			events.disconnect (btn:getClickedSignalProxy(), conn_id)
			underworld2.timed_events:queue (underworld2.server_time() + 0.5, function() t:next_stage() end)
		end)
		underworld2.ui.window:add_subview (finger)

		return function()
			ui.core.view_controller.instance:resetTouchEventFilter()
		end, "open_trading_menu"
	end,

	--[3] "The Buying tab shows the actual offers in the area around you. You gotta sow before you reap, right?"
	function (t)
		underworld2.ui.main_view.ui.commodities:setEnabled (false)
		underworld2.timed_events:queue (underworld2.server_time() + 0.5, function()
			underworld2.ui.main_view.ui.commodities:setEnabled (true)
			local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_03"), "ui/characters/ch_advisor_modal:filtered")
			ui.core.view.delegate_builder (
			{
				finished = function (self)
					ui.core.view_controller:close_modal_view (self)
					t:next_stage()
				end
			}).build (view)

			ui.core.view_controller:show_modal_view (view)
		end)
		return nil, "message2"
	end,

	--[4] reversed horizontal swipe finger is pointing at the trading card(switch to first commodity)
	function (t)
		local finger = underworld2.ui.main_view:start_card_swipe_tutorial (1)
		underworld2.ui.window:add_subview (finger)

		return function (t)
			underworld2.ui.window:remove_subview (finger)
			finger:finalize()
			underworld2.ui.main_view:end_card_swipe_tutorial()
			underworld2.ui.main_view.ui.commodities:lockPageMove()
		end, "swipe_card"
	end,
	--[5] "Deals have different conditions: Amount offered, Price and Delivery Time.."
	function (t)
		underworld2.ui.main_view.ui.commodities:setEnabled (false)
		underworld2.timed_events:queue (underworld2.server_time() + 0.5, function()
			underworld2.ui.main_view.ui.commodities:setEnabled (true)
			local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_05"), "ui/characters/ch_advisor_modal:filtered")
			ui.core.view.delegate_builder (
			{
				finished = function (self)
					ui.core.view_controller:close_modal_view (self)
					t:next_stage()
				end
			}).build (view)

			ui.core.view_controller:show_modal_view (view)
		end)
		return nil, "message3"
	end,

	--[6] "Deals have different conditions: Amount offered, Price and Delivery Time.."
	function (t)
		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_06"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message4"
	end,

	--[7] Action: tap finger is pointing at the first deal in the list(select first deal)
	function (t)
		local finger = underworld2.ui.main_view:start_offer_selection_tutorial()
		underworld2.ui.window:add_subview (finger)

		return function()
			underworld2.ui.window:remove_subview (finger)
			finger:finalize()
		end, "select_offer"
	end,

	--[8] Action: down-up finger is pointing at the barrel 
	function (t)
		local card = underworld2.ui.main_view.cards[1]
		card:startDealTutorial()
		return nil, "select_purchase_amount"
	end,

	--[9] Action: tap finger is pointing at the "Buy" button; nothing works until Player taps it
	function (t)
		return nil, "confirm_purchase"
	end,

	--[10] "Every time you cut a deal, your Runners handle the grunt work. No need to get your hands dirty"
	function (t)
		underworld2.ui.main_view.ui.commodities:setEnabled (false)
		underworld2.timed_events:queue (underworld2.server_time() + 0.5, function()
			underworld2.ui.main_view.ui.commodities:setEnabled (true)
			local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_10"), "ui/characters/ch_advisor_modal:filtered")
			ui.core.view.delegate_builder (
			{
				finished = function (self)
					ui.core.view_controller:close_modal_view (self)
					t:next_stage()
				end
			}).build (view)

			ui.core.view_controller:show_modal_view (view)
		end)
		return nil, "message5"
	end,

	--[11] "Hey, guys, come in!.. Meet Brick and Jay, from now on they are working for you"
	function (t)
		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_11"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)
		return nil, "message5_1"
	end,

	--[12] (Brick and Jay picture, Brick talking): "You're the new boss? I see... Ok, let me handle this."
	--Important: the buy flow animation should only be made after this step!
	function (t)
		local view = t:create_brief_view (L ("KEY_BRICK"), L ("KEY_TUTORIAL_INITIAL_P1_12"), "ui/characters/ch_runner_modal_1:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				
				local player = underworld2.player
				local courier = player:getCourierAt (0)

				local courier = player:getCourierAt (0)
				local now = underworld2.server_time()

				underworld2.ui.main_view.dealers_overlay:removeCourier (courier:getId())

				local shop  = _shops[1]
				local owner = _owners[shop.owner_id]

				courier:setDealerId (owner.id)
				courier:setCommodityId (shop.id)
				courier:setItemsAmount (shop.count)
				courier:setPricePerItem (shop.sell_price)
				courier:setMoney (0)
				courier:setState (underworld2.CourierStatePurchasing)
				courier:setStartTime (now)
				courier:setEndTime (now + shop.duration)
				courier:setBoostCoefficient (0)
				courier:setRespectPoints (player_state_cache.rp * 0.5)

				local overlay = underworld2.ui.main_view.dealers_overlay
				overlay:addTutorialCourier (courier, true)
				overlay:animatePathToDeal (courier:getId())

				local filter = ui.DealersOverlayDealsInputFilter()
				filter:add (overlay, courier:getId())
				overlay:setInputFilter (filter)

				player:removeMoney (shop.count * shop.sell_price)

				local profile = underworld2.ProfileDatabase():get (owner.id)

				underworld2.ui.main_view:show_map (true)
				underworld2.ui.main_view.ui.map_tile:setEnabled (false)
				underworld2.timed_events:queue (underworld2.server_time() + 1.0, function() 
					t:next_stage()
				end)
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message6"
	end,

	--[13] "Delivery takes time, even the best Runners can't teleport. How long? Well, that depends on the Goods and Distance."
	function (t)
		underworld2.ui.main_view.ui.map_tile:setEnabled (false)
		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_13"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				local courier = underworld2.player:getCourierAt (0)
				underworld2.timed_events:queue (courier:getEndTime(), function() t:next_stage() end)
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)
		return nil, "message7"
	end,

	--[14] Brick talking: "We've delivered the goods, boss."
	function (t)
		underworld2.ui.main_view.ui.map_tile:setEnabled (false)
		local view = t:create_brief_view (L ("KEY_BRICK"), L ("KEY_TUTORIAL_INITIAL_P1_14"), "ui/characters/ch_runner_modal_1:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				underworld2.ui.main_view.ui.map_tile:setEnabled (true)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)
		return nil, "message8"
	end,

	-- [15] collect animation
	function  (t)
		local conn_id -- upvalue
		conn_id = events.connect (underworld2.player:getCourierStateChangedSignalProxy(), function ()
			events.disconnect (underworld2.player:getCourierStateChangedSignalProxy(), conn_id)
			underworld2.timed_events:queue (underworld2.server_time() + 2.0, function() t:next_stage() end)
		end)
		return nil, "collect_items"
	end,

	-- [16] "By the way, let's think you up a proper street name."
	function (t)
		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_16"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)
		return nil, "message9"
	end,

	-- [17] show 'enter name' dialog
	function (t)
		underworld2.show_enter_name_dialog (underworld2.player:getNickname(), function()
			t:next_stage()
		end)
		return nil, "enter_name"
	end,

	-- [18] "Buying's only half the battle, Ace. Let's check the pipelines and see if we can make some profit with those goods." 
	function (t)
		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_18"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message10"
	end,

	-- [19] tap finger is pointing to Home button(open trade card at commodity 2 in buying mode)
	function (t)
		underworld2.ui.main_view:set_current_item (1)
		underworld2.ui.main_view:unlock_trade_gesture()
		local btn = underworld2.ui.main_view.ui.btn_market
		ui.core.view_controller.instance:setTouchEventFilter (btn:mapToRoot (btn:getOrigin()), btn:getSize())
		local pos = btn:mapToRoot (btn:getOrigin()) + btn:getSize() * 0.5
		local finger = underworld2.tutorial:create_tap_view (pos, math.pi)
		local conn_id 
		conn_id = events.connect (btn:getClickedSignalProxy(), function()
			ui.core.view_controller.instance:setTouchEventFilter(math.vec2 (0, 0), math.vec2 (0, 0))
			underworld2.ui.main_view:lock_trade_gesture()
			underworld2.ui.window:remove_subview (finger)
			finger:finalize()
			events.disconnect (btn:getClickedSignalProxy(), conn_id)
			underworld2.timed_events:queue (underworld2.server_time() + 0.5, function() t:next_stage() end)
		end)
		underworld2.ui.window:add_subview (finger)

		return function (t)
			ui.core.view_controller.instance:resetTouchEventFilter()
		end, "open_trading_menu2"
	end,

	-- [20] switch to selling
	function (t)
		local finger = underworld2.ui.main_view:start_switch_to_selling_tutorial()
		underworld2.ui.window:add_subview (finger)
		return function (t)
			underworld2.ui.window:remove_subview (finger)
			ui.core.view_controller.instance:setTouchEventFilter (math.vec2 (0, 0), math.vec2 (0, 0))
		end, "switch_to_selling"
	end,

	-- [21] Deals are sorted from highest bidder to lower. Let's go for the most profitable one.
	function (t)
		underworld2.ui.main_view.ui.map_tile:setEnabled (false)
		underworld2.timed_events:queue (underworld2.server_time() + 0.5, function()
			ui.core.view_controller.instance:resetTouchEventFilter()
			underworld2.ui.main_view.ui.map_tile:setEnabled (true)
			local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_21"), "ui/characters/ch_advisor_modal:filtered")
			ui.core.view.delegate_builder (
			{
				finished = function (self)
					ui.core.view_controller:close_modal_view (self)
					t:next_stage()
				end
			}).build (view)

			ui.core.view_controller:show_modal_view (view)
		end)
		return nil, "message11"
	end,

	-- [22] select first row in orders
	function (t)
		local finger = underworld2.ui.main_view:start_order_selection_tutorial()
		underworld2.ui.window:add_subview (finger)
		return function (t)
			underworld2.ui.window:remove_subview (finger)
			finger:finalize()
		end, "select_order"
	end,

	-- [23] Action: down-up finger is pointing at the barrel
	function (t)
		local card = underworld2.ui.main_view.cards[1]
		card:startDealTutorial()
		return nil, "select_selling_amount"
	end,

	-- [24] Action: tap finger is pointing at the "Sell" button
	function (t)		
		return nil, "confirm_sale"
	end,

	-- [25] Brick talking: "That fella was pretty far away, so delivery will take a while. But we could use a shortcut to get your hands on it right now..."
	function (t)
		underworld2.ui.main_view.ui.map_tile:setEnabled (false)
		underworld2.timed_events:queue (underworld2.server_time() + 0.5, function()
			underworld2.ui.main_view.ui.map_tile:setEnabled (true)
			local view = t:create_brief_view (L ("KEY_BRICK"), L ("KEY_TUTORIAL_INITIAL_P1_25"), "ui/characters/ch_runner_modal_1:filtered")
			ui.core.view.delegate_builder (
			{
				finished = function (self)
					ui.core.view_controller:close_modal_view (self)
					t:next_stage()
				end
			}).build (view)

			ui.core.view_controller:show_modal_view (view)
		end)

		return nil, "message12"
	end,

	-- [26] Brick talking: "...but we need additional Gold to get it delivered right away"
	function (t)
		local view = t:create_brief_view (L ("KEY_BRICK"), L ("KEY_TUTORIAL_INITIAL_P1_26"), "ui/characters/ch_runner_modal_1:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)

				local player = underworld2.player
				local courier = player:getCourierAt (0)
				local now = underworld2.server_time()

				underworld2.ui.main_view.dealers_overlay:removeCourier (courier:getId())

				local shop  = _shops[6]
				local owner = _owners[shop.owner_id]

				courier = player:getCourierAt (0)
				courier:setDealerId (owner.id)
				courier:setCommodityId (1)
				courier:setItemsAmount (shop.max_purchase_count)
				courier:setPricePerItem (0)
				courier:setMoney (shop.max_purchase_count * shop.purchase_price)
				courier:setState (underworld2.CourierStateSelling)
				courier:setStartTime (now)
				courier:setEndTime (now + shop.duration)
				courier:setBoostCoefficient (7)
				courier:setRespectPoints (player_state_cache.rp * 0.5)

				local overlay = underworld2.ui.main_view.dealers_overlay
				overlay:addTutorialCourier (courier, false)
				overlay:animatePathToDeal (courier:getId())

				local filter = ui.DealersOverlayDealsInputFilter()
				filter:add (overlay, courier:getId())
				overlay:setInputFilter (filter)

				player:removeItemsFromStorage (1, shop.max_purchase_count)

				local profile = underworld2.ProfileDatabase():get (owner.id)

				underworld2.ui.main_view:show_map (true)
				underworld2.ui.main_view.ui.map_tile:setEnabled (false)

				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message13"
	end,

	-- [27] Action: tap finger is pointing at the deal + Action: tap finger is pointing at "deliver now" button
	function (t)
		underworld2.ui.main_view.ui.map_tile:setEnabled (true)
		local on_finished
		on_finished = function (url) 
			network.online_controller.default.request_completed:disconnect (on_finished)
			t:next_stage()
		end
		network.online_controller.default.request_completed:connect (on_finished)

		return nil, "boost_deal"
	end,

	-- [28] Action: tap finger is pointing at the deal
	function (t)
		local conn_id -- upvalue
		conn_id = events.connect (underworld2.player:getCourierStateChangedSignalProxy(), function ()
			events.disconnect (underworld2.player:getCourierStateChangedSignalProxy(), conn_id)
			underworld2.timed_events:queue (underworld2.server_time() + 2.0, function() t:next_stage() end)
		end)
		return nil, "collect_money"
	end,

	-- [29] Show levelup screen
	function (t)

		get_sound_pool():play ("ui/SFX_LevelUp.wav")
		local v = ui.core.view.builder (ui.levelup).build (2, false)
		ui.core.view_controller:show_modal_view (v)
		v.delegate_builder (
		{
			finished = function (v)
				ui.core.view_controller:close_modal_view (v)
				t:next_stage()
			end
		}).build (v)
		return nil, "show_levelup"
	end,

	-- [30] "Looks like our training already paid off, Ace! You've got a new rank on the streets! It's time to buy some equipment."
	function (t)
		underworld2.ui.main_view.ui.map_tile:setEnabled (true)
		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_30"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				underworld2.ui.main_view.ui.commodities:unlockPageMove()
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message14"
	end,

	-- [31] Action: tap finger is pointing at "Menu" button
	--[[function (t)
		underworld2.ui.status_panel:enable()
		
		local btn = underworld2.ui.status_panel.ui.profile
		ui.core.view_controller.instance:setTouchEventFilter (btn:mapToRoot (btn:getOrigin()), btn:getSize())
		local pos = btn:mapToRoot (btn:getOrigin()) + btn:getSize() * 0.5
		local finger = underworld2.tutorial:create_tap_view (pos, math.pi * 0.25)
		underworld2.ui.window:add_subview (finger)

		-- fwd
		local conn_id 
		conn_id = events.connect (btn:getClickedSignalProxy(), function()
			underworld2.ui.status_panel:disable()
			underworld2.ui.window:remove_subview (finger)
			events.disconnect (btn:getClickedSignalProxy(), conn_id)
			underworld2.timed_events:queue (underworld2.server_time() + 0.5, function() t:next_stage() end)
		end)
		return nil, "open_side_menu"
	end,]]

	-- [32] Action: tap finger is pointing at "Equipment"
	function (t)
		underworld2.ui.main_view:unlock_trade_gesture()
		local btn = underworld2.ui.main_view.ui.btn_equipment
		ui.core.view_controller.instance:setTouchEventFilter (btn:mapToRoot (btn:getOrigin()), btn:getSize())
		local pos = btn:mapToRoot (btn:getOrigin()) + btn:getSize() * 0.5
		local finger = underworld2.tutorial:create_tap_view (pos, math.pi)
		local conn_id 
		conn_id = events.connect (btn:getClickedSignalProxy(), function()
			ui.core.view_controller.instance:setTouchEventFilter(math.vec2 (0, 0), math.vec2 (0, 0))
			underworld2.ui.main_view:lock_trade_gesture()
			underworld2.ui.window:remove_subview (finger)
			finger:finalize()
			events.disconnect (btn:getClickedSignalProxy(), conn_id)
			underworld2.timed_events:queue (underworld2.server_time() + 1.5, function() t:next_stage() end)
		end)
		underworld2.ui.window:add_subview (finger)
		return function()
			ui.core.view_controller.instance:resetTouchEventFilter()
		end, "show_equipment"
	end,

	-- [33] "First things first. You need a storage and a place to crash when shit hits the fan. So go ahead, buy a safehouse."
	function (t)
		underworld2.ui.main_view.ui.map_tile:setEnabled (true)
		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_33"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				ui.core.view_controller:close_modal_view (self)
				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "message15"
	end,

	-- [34] Action: tap finger is pointing at Safehouse slot
	function (t)

		local window = underworld2.ui.stack:top()
		local btn = window.slots[1]
		ui.core.view_controller.instance:setTouchEventFilter (btn:mapToRoot (btn:getOrigin()), btn:getSize())
		local pos = btn:mapToRoot (btn:getOrigin()) + btn:getSize() * 0.5
		local finger = underworld2.tutorial:create_tap_view (pos, 0.0)
		underworld2.ui.window:add_subview (finger)
		local conn_id
		conn_id = events.connect (btn:getClickedSignalProxy(), function()
			underworld2.ui.window:remove_subview (finger)
			events.disconnect (btn:getClickedSignalProxy(), conn_id)
			-- delayed next_stage call also makes possible to avoid issues related to the signal handler call order  
			underworld2.timed_events:queue (underworld2.server_time() + 0.5, function() t:next_stage() end)
		end)
		return nil, "show_equipment_shop"
	end,

	-- [35] Action: tap finger is pointing at first safehouse item's buy button
	function (t)
		ui.core.view_controller.instance:setTouchEventFilter (math.vec2 (0, 0), math.vec2 (0, 0))

		local window = underworld2.ui.stack:top()
		local wrapper = window.rows_cache[1]
		wrapper:set_state (ui.widgets.item_widget.STATE_NOT_PURCHASED)
		local btn = wrapper.btns.buy
		local finger
		window.items_scroll:setScrollEnabled (false)

		underworld2.timed_events:queue (underworld2.server_time() + 0.2, function()
			ui.core.view_controller.instance:setTouchEventFilter (btn:mapToRoot (btn:getOrigin()), btn:getSize())
			local pos = btn:mapToRoot (btn:getOrigin()) + btn:getSize() * 0.5
			finger = underworld2.tutorial:create_tap_view (pos, 0.0)
			underworld2.ui.window:add_subview (finger)
		end)

		wrapper.handlers = {
			buy = function()
				underworld2.ui.window:remove_subview (finger)
				local item 		= wrapper.item
				local item_id 	= item:getId()

				local player = underworld2.player

				local now = underworld2.server_time()
				local delivery_duration = underworld2.ItemsDeliveryTimeDatabase():get (item:getLevelRequired())
				local delivery_time = underworld2.server_time() + delivery_duration
				
				player:removeMoney (item:getPrice())
				player:addToBackpack (item)
				player:setPendingItem (item, now, delivery_time, 7)
				wrapper:set_delivery_time (delivery_time, delivery_duration)
				wrapper:set_state (ui.widgets.item_widget.STATE_IN_DELIVERY)

				t:next_stage()
			end,
			sell = function() end,
			equip = function() end,
			unequip = function() end,
			equip_now = function() end,
		}

		return nil, "buy_safehouse"
	end,

	-- [36] Action: tap finger is pointing at "deliver" button
	function (t)
		ui.core.view_controller.instance:setTouchEventFilter (math.vec2 (0, 0), math.vec2 (0, 0))

		local window = underworld2.ui.stack:top()
		local wrapper = window.rows_cache[1]
		local btn = wrapper.btns.boost
		local finger

		local finger_show_time = underworld2.server_time() + 0.2
		underworld2.timed_events:queue (underworld2.server_time() + 0.2, function()
			ui.core.view_controller.instance:setTouchEventFilter (btn:mapToRoot (btn:getOrigin()), btn:getSize())
			local pos = btn:mapToRoot (btn:getOrigin()) + btn:getSize() * 0.5
			finger = underworld2.tutorial:create_tap_view (pos, 0.0)
			underworld2.ui.window:add_subview (finger)
		end)

		local equip_now = function()
			underworld2.ui.window:remove_subview (finger)

			local item 		= wrapper.item
			--local item_id 	= item:getId()

			local player = underworld2.player
			--local price = player:getItemDeliveryPrice (item_id, underworld2.server_time())
			player:setItemDelivered (item:getId())
			wrapper:set_state (ui.widgets.item_widget.STATE_OWNED)

			t:next_stage()
		end

		local end_time = underworld2.player:getItemDeliveryTime (wrapper.item:getId())
		end_time = math.max (finger_show_time, end_time - 1.0)

		local event_id
		event_id = underworld2.timed_events:queue (end_time, function()
			event_id = nil
			equip_now()
		end)

		wrapper.handlers.equip_now = function()
			if event_id then
				underworld2.timed_events:unqueue (event_id)
			end
			equip_now()
		end

		return nil, "boost_item_delivery"
	end,

	-- [37] Action: tap finger is pointing at "Equip" button
	function (t)
		ui.core.view_controller.instance:setTouchEventFilter (math.vec2 (0, 0), math.vec2 (0, 0))

		local window = underworld2.ui.stack:top()
		local wrapper = window.rows_cache[1]
		local btn = wrapper.btns.equip
		local finger

		underworld2.timed_events:queue (underworld2.server_time() + 0.2, function()
			ui.core.view_controller.instance:setTouchEventFilter (btn:mapToRoot (btn:getOrigin()), btn:getSize())
			local pos = btn:mapToRoot (btn:getOrigin()) + btn:getSize() * 0.5
			finger = underworld2.tutorial:create_tap_view (pos, 0.0)
			underworld2.ui.window:add_subview (finger)
		end)

		wrapper.handlers.equip = function()
			ui.core.view_controller.instance:resetTouchEventFilter()

			underworld2.ui.window:remove_subview (finger)

			local player = underworld2.player
			local item, slot = wrapper.item, wrapper.slot
			local item_id, slot_id = item:getId(), slot:getId()

			wrapper:set_state (ui.widgets.item_widget.STATE_EQUIPED)

			window.slot_btns[slot_id]:setItem (item)

			player:equipItem (slot_id, item_id)
			window:update_stats_diff()
			window.items_scroll:setScrollEnabled (true)

			t:next_stage()
		end
		return nil, "equip_item"
	end,

	-- [39] "Okay, those were the basics. You have potential, but don't let it get to your head. I'll stay in touch. Later, Ace."
	function (t)
		underworld2.player:setLevel (player_state_cache.level_id)
		underworld2.player:setRespectPoints (player_state_cache.rp)
		underworld2.player:setGold (player_state_cache.gold)
		underworld2.player:setMoney (player_state_cache.cash)

		underworld2.ui.status_panel:enable()
		underworld2.ui.main_view:unlock_map_move()
		underworld2.ui.main_view:unlock_trade_gesture()
		underworld2.ui.main_view.ui.map_tile:setEnabled (true)

		underworld2.ui.main_view.dealers_overlay:setInputFilter (nil)

		local view = t:create_brief_view (L ("KEY_ADVISOR"), L ("KEY_TUTORIAL_INITIAL_P1_39"), "ui/characters/ch_advisor_modal:filtered")
		ui.core.view.delegate_builder (
		{
			finished = function (self)
				network.online_controller.default = default_online_controller

				ui.core.view_controller:close_modal_view (self)

				ui.removeTextureFromPreloadList ("ui/characters/ch_advisor_modal:filtered")
				ui.removeTextureFromPreloadList ("ui/characters/ch_runner_modal_1:filtered")
				ui.removeTextureFromPreloadList ("ui/tutorial/tutorial_finger_ill:filtered")
				ui.removeTextureFromPreloadList ("ui/modal_wide_window:filtered")

				t:next_stage()
			end
		}).build (view)

		ui.core.view_controller:show_modal_view (view)

		return nil, "finished"
	end,
}

tutorial.initial = stages