require "ui/text_styles.lua"

ui.config = 
{
	screen_ratio	= ui.DeviceMetrics():getScreenRatio(),
	hspacing 		= 0.01,
	vspacing 		= 0.01 * ui.DeviceMetrics():getScreenRatio(),

	shop_types = 
	{
		unknown = { icon = "ui/map/block_icon:filtered", anchor = math.vec2 (0.5, 0.5) },
		you		= { icon = "ui/map/pin_ico:filtered", anchor = math.vec2 (0.33, 1.0) },
		dealer  = { icon = "ui/map/pin_dealer:filtered", anchor = math.vec2 (0.5, 0.5) },
		lab		= { icon = "ui/map/pin_dealer:filtered", anchor = math.vec2 (0.5, 0.5) },
		junkie	= { icon = "ui/map/pin_dealer:filtered", anchor = math.vec2 (0.5, 0.5) },
	},

	commodity_icons = bundle.resources.commodity_icons,
	commodity_small_icons = bundle.resources.commodity_small_icons,
	commodity_images = bundle.resources.commodity_images,

	quests = 
	{
		-- resources associated with quest characters
		-- each subcategory should provide 'default' image id
		characters = {
			["modal"] = { 
				["default"] 	= "ui/characters/ch_job_modal_0:filtered",
				["Bouncer"] 	= "ui/characters/ch_job_modal_1:filtered",
				["Hipster"] 	= "ui/characters/ch_job_modal_3:filtered",
				["Mexican guy"] = "ui/characters/ch_job_modal_5:filtered",
				["Punk Girl"] 	= "ui/characters/ch_job_modal_4:filtered",
				["Street goth"] = "ui/characters/ch_job_modal_2:filtered",
			},
			["map"] = {
				["default"] 	= "ui/job_map_characters/ch_job_map_0:filtered",
				["Bouncer"] 	= "ui/job_map_characters/ch_job_map_1:filtered",
				["Hipster"] 	= "ui/job_map_characters/ch_job_map_3:filtered",
				["Mexican guy"] = "ui/job_map_characters/ch_job_map_5:filtered",
				["Punk Girl"] 	= "ui/job_map_characters/ch_job_map_4:filtered",
				["Street goth"] = "ui/job_map_characters/ch_job_map_2:filtered",
			},
			get_resource_id = function (category, char_id)
				local cat = ui.config.quests.characters[category]
				return cat[char_id] or cat["default"]
			end
		}
	},

	offer_style =
	{
		row_texture 	= "ui/my_offer_row",
		sep_texture 	= "ui/line_sep_sell",
		sep_tstyle  	= ui.text_styles.commodity_offer_sep,
		title_tstyle 	= ui.text_styles.commodity_header_offer,
		btn_texture		= "ui/btn_yellow:filtered"
	},

	order_style = 
	{
		row_texture 	= "ui/my_order_row",
		sep_texture 	= "ui/line_sep_buy",
		sep_tstyle  	= ui.text_styles.commodity_order_sep,
		title_tstyle	= ui.text_styles.commodity_header_order,
		btn_texture 	= "ui/btn_lower_normal:filtered"
	},
}
