local text_style = { }

function text_style:setup_outline (enabled, radius)
	self.outline_enabled = enabled
	self.outline_radius = radius or self.radius
	return self
end

function text_style:setup_shadow (enabled, offset)
	self.shadow_enabled = enabled
	self.shadow_offset = offset or self.shadow_offset
	return self
end

function text_style:set_secondary_color (color)
	self.secondary_color = color
	return self
end

function text_style:set_dpi_dependent (dep)
	self.dpi_dependent = dep
	return self
end

ui.core = ui.core or {}

ui.core.text_style_builder = function (size, color, font)
	local style = setmetatable ({
		size = size,
		primary_color = color,
		secondary_color = render.color_black,
		font = font,
		
		outline_enabled = false,
		outline_radius = 1,
		
		shadow_enabled = false,
		shadow_offset = math.vec2(1, 1),

		dpi_dependent = false,
	}, { __index = text_style})

	style.build = function()
		local obj = ui.TextStyle (style.size, style.primary_color, style.font, style.dpi_dependent and ui.TextStyle_SizeUnitPoint or ui.TextStyle_SizeUnitDIP)
		if style.outline_enabled then
			obj:setOutlineRadius (style.outline_radius)
			obj:setOutlineEnabled (true)
		end
		if style.shadow_enabled then
			obj:setShadowOffset (style.shadow_offset)
			obj:setShadowEnabled (true)
		end
		obj:setSecondaryColor (style.secondary_color)
		return obj
	end

	return style
end