
ui 		= ui or { }
ui.core = ui.core or { }

local vc = { 
	instance = ui.ViewController(),
	modal_views = { }
}

function vc:set_root_view (view)
	self.instance:setRootView (view._pdata)
end

function vc:show_modal_view (view, blur)
	if blur == nil then blur = true end
	self.instance:showModalView (view._pdata, blur)
	self.modal_views[view] = true
end

function vc:close_modal_view (view)
	if self.modal_views[view] then
		self.instance:closeModalView (view._pdata)
		self.modal_views[view] = nil
	end
end

function vc:has_modal_views()
	local v, i = next (self.modal_views)
	return v ~= nil
end

function vc:update (t)
	self.instance:update (t)
end

ui.core.view_controller = vc 
