require "ui/core/view.lua"
require "ui/text_styles.lua"
require "ui/widgets/dealer.lua"

local view = setmetatable ({ }, { __index = ui.core.view })
ui.dealer_stack = view

local builder = ui.core.view.builder (view)

function view.create (dealers)
	local obj = builder.build()
	obj:set_dealers (dealers)
	return obj
end


function view:back()
	--self.result = view.RESULT_CANCEL
	self:finalize()
end

function view:build_ui()

	local root_widget = ui.Frame("frame")
	root_widget:setBordersTexture ("ui/window_dealer_stack")
	root_widget:setOrigin(0.1, 0.3)
	root_widget:setSize(0.8, 0.6)
	root_widget:addChild (frame)

	local scroll = ui.ScrollWidget()
	scroll:setOrigin (0.0, 0.0)
	scroll:setSize (0.8 - root_widget:getLeftMargin() - root_widget:getRightMargin(), 0.6 - root_widget:getTopMargin() - root_widget:getBottomMargin())
	scroll:setScrollType (ui.ScrollTypeVertical)
	root_widget:addChild (scroll)
	
	local vlayout = ui.VerticalLayout()
	vlayout:setItemSpacing (ui.config.vspacing)
	
	scroll:setLayout (vlayout)
	
	self.ui = 
	{
		layout 		= vlayout
	}

	return root_widget
end

function view:set_dealers (dealers)
	local close = function () self:finalize() end
	for i, v in ipairs (dealers) do
		local w = ui.widgets.dealer.create (v)
		events.connect (w:getClickedSignalProxy(), close)
		self.ui.layout:addWidget (w)
	end
end

