require "ui/core/view.lua"
require "ui/widgets/dealer.lua"

require "ui/modal/inbox.lua"

local wrapper = { }

ui.dealer_list_wrapper = wrapper

function wrapper.create (list, close_handler)
	local obj = setmetatable ( { ui = { }, deal = deal }, {__index = wrapper} )

	local handler = function (btn) 
		ui.inbox.show_chat (btn:getTag())
		close_handler()
	end

	local frame = ui.Frame()
	frame:setBordersTexture ("ui/window_dealer_stack:filtered")
	
	local item_spacing = ui.config.vspacing * 0.5

	local list_scroll = ui.ScrollWidget()
	list_scroll:setScrollType (ui.ScrollTypeVertical)

	local first = ui.widgets.dealer.create (list[1], handler)
	local item_size = first:getPreferredSize()

	local frame_size = math.vec2 (item_size.x + frame:getLeftMargin() + frame:getRightMargin(), math.min (0.5, frame:getTopMargin() + frame:getBottomMargin() + item_size.y * #list + item_spacing * (#list - 1)))
	frame:setSize (frame_size)

	list_scroll:setSize (frame_size.x - (frame:getLeftMargin() + frame:getRightMargin()), frame_size.y - (frame:getTopMargin() + frame:getBottomMargin()))

	local list_layout = ui.VerticalLayout()
	list_layout:setItemSpacing (item_spacing)

	list_layout:addWidget (first)
	for i = 2, #list do
		local btn = ui.widgets.dealer.create (list[i], handler)
		list_layout:addWidget (btn)
	end

	list_scroll:setLayout (list_layout)
	frame:addChild (list_scroll)

	obj.ui.widget = frame

	return obj
end

function wrapper:update (dt)
end
