require "ui/core/view.lua"

local view = setmetatable ( {}, { __index = ui.core.view } )

ui.fade_view = view

local builder = ui.core.view.builder (view)

function view.create (parent_window)
	local v = builder.build()
	v.parent_window = parent_window
	v:start_fade_in()
	return v
end

function view:build_ui()
	local W = ui.Picture ()
	W:setTexture ("ui/fade:filtered")
	W:setPlacingMode(ui.Picture_PlacingModeStretch)
	W:setSize (1.0, 1.0)
	W:setOrigin (0.0, 0.0)

	local button = ui.ImageButton()
	button:setSize (1.0, 1.0)
	button:setOrigin (0.0, 0.0)
	events.connect (button:getClickedSignalProxy(), function() self:dismiss() end)

	W:addChild (button)

	return W
end

function view:hide()
	self:start_fade_out()
end

function view:dismiss()
end

function view:start_fade_in()
	self.parent_window:add_subview (self)
end

function view:start_fade_out()
	self.parent_window:remove_subview (self)
	self:finalize()
end
