require "ui/core/view.lua"
require "ui/config.lua"
require "ui/format.lua"

local view = setmetatable ( { }, { __index = ui.core.view } )
ui.chat = view

local builder = ui.core.view.builder(view)

function view.create ()
	local v = builder.build()
	return v
end

local function build_header_widget (on_close)

	local widget = ui.Widget()
	widget:setMargins (ui.config.hspacing * 2, ui.config.hspacing * 2, ui.config.vspacing * 2, ui.config.vspacing * 2)

	local layout = ui.HorizontalLayout()

	local pic = ui.Picture()
	pic:setTexture ("ui/messaging/ico_inbox_large:filtered")
	pic:setHorizontalSizePolicy (ui.SizePolicyMinimum)
	layout:addWidget (pic)

	local title = ui.TextLabel()
	title:setTextStyle (ui.text_styles.modal_window_title.build)
	title:setText (L ("KEY_INBOX_WINDOW_TITLE"))
	layout:addWidget (title)

	local close = ui.ImageButton ()
	close:setTexture ("ui/btn_close:filtered")
	close:setSound ("ui/UI_Back.wav")
	close:setHorizontalSizePolicy (ui.SizePolicyMinimum)
	events.connect (close:getClickedSignalProxy(), on_close)
	layout:addWidget (close)

	widget:setLayout (layout)

	return widget
end

function view:build_ui()

	local root = ui.Widget()

	local layout = ui.VerticalLayout()

	local header = build_header_widget()
	header:setVerticalSizePolicy (ui.SizePolicyMinimum)
	layout:addWidget (header)



end
