require "ui/core/view.lua"
require "ui/text_styles.lua"

local view = setmetatable ({ }, { __index = ui.core.view })
ui.error = view

local builder = ui.core.view.builder (view)

function view.create (text)
	local obj = builder.build()
	if text then
		obj:set_text (text)
	end
	return obj
end

function view:back()
	--self.result = view.RESULT_CANCEL
	self:finalize()
end

function view:build_ui()
	self.ui = { }

	local root_widget = ui.Frame("root_widget")
	root_widget:setBordersTexture ("ui/window_modal_large:filtered")
	root_widget:setSize(0.7, 0.2)
	root_widget:setOrigin(0.15, 0.4)

	local vlayout = ui.VerticalLayout()

	local message = ui.TextLabel()
	message:setTextStyle (ui.text_styles.small_hl.build())
	message:setTextAlignment (ui.AlignmentHorizontalCenter + ui.AlignmentVerticalCenter)
	vlayout:addWidget (message)

	self.ui.message = message

	root_widget:setLayout (vlayout)

	return root_widget
end

function view:set_text( text )
	self.ui.message:setText (text)
end

function view.show (text)
	ui.core.view_controller:show_modal_view (view.create (text))
end