ui.my_offer_widget =
{

}

function ui.my_offer_widget.create()
	local obj = setmetatable ({ ui = { } }, { __index = ui.my_offer_widget })

	local button = ui.TextButton()
	button:setTexture (ui.config.offer_style.row_texture)

	local layout = ui.HorizontalLayout()
	layout:setItemSpacing (ui.config.hspacing)

	local avatar = ui.Picture()
	avatar:setTexture("ui/avatars/avatar"..((underworld2.profile.id % 10) + 1))
	avatar:setPlacingMode(ui.Picture_PlacingModeCenter)
	avatar:setHorizontalSizePolicy (ui.SizePolicyMinimum)

	layout:addWidget (avatar)

	do
		local vlayout = ui.VerticalLayout()

		local nickname = ui.TextLabel()
		nickname:setText (underworld2.profile.nickname)
		nickname:setTextStyle (ui.text_styles.dealer_nickname_hl.build())

		local hlayout = ui.HorizontalLayout()
		hlayout:setItemSpacing (ui.config.hspacing)

		local count_ico = ui.Picture()
		count_ico:setTexture("ui/ico_box_small")
		count_ico:setPlacingMode(ui.Picture_PlacingModeCenter)
		count_ico:setHorizontalSizePolicy (ui.SizePolicyMinimum)

		local count = ui.TextLabel()
		count:setTextStyle (ui.text_styles.dealer_info_hl.build())

		hlayout:addWidget (count_ico)
		hlayout:addWidget (count)

		vlayout:addWidget (nickname)
		vlayout:addItem (hlayout)

		layout:addItem (vlayout)

		obj.ui.count = count
	end	

	
	local price = ui.TextLabel()
	price:setTextStyle (ui.text_styles.dealer_price_hl.build())
	price:setTextAlignment (ui.AlignmentHorizontalRight + ui.AlignmentVerticalCenter)

	layout:addWidget (price)

	local arrow_ico = ui.Picture()
	arrow_ico:setTexture("ui/arrow_off_ico")
	arrow_ico:setPlacingMode(ui.Picture_PlacingModeCenter)
	arrow_ico:setHorizontalSizePolicy (ui.SizePolicyMinimum)

	layout:addWidget (arrow_ico)
	
	button:setLayout (layout)

	obj.ui.root = button
	obj.ui.price = price

	return obj
end 

function ui.my_offer_widget:set_offer (offer)
	self.ui.price:setText ("$"..offer.sell_price)
	self.ui.count:setText (offer.count)
end
