require "ui/core/view.lua"
require "ui/text_styles.lua"
require "ui/config.lua"

local view = setmetatable ({ }, { __index = ui.core.window })
ui.render_test = view

local builder = ui.core.view.builder (view)

function view.create ()
	local obj = builder.build()
	return obj
end

function view:build_ui()
	--[[local widget = ui.Picture()
	widget:setOrigin (0.0 / 640.0, 0.0 / 960.0)
	widget:setSize (1.0, 1.0)
	widget:setTexture ("ui/bar_param_background:filtered")]]
	
	local widget = ui.Widget()
	widget:setOrigin (0.0, 0.0)
	widget:setSize (1.0, 1.0)

	local vlayout = ui.VerticalLayout()
	vlayout:setItemSpacing (ui.config.vspacing)

	for i = 1, 10 do
		local hlayout = ui.HorizontalLayout()
		hlayout:setItemSpacing (ui.config.hspacing)
		for j = 1, 50 do
			local avatar = ui.Picture()
			avatar:setTexture("ui/ico_experience_rew:filtered")
			avatar:setPlacingMode(ui.Picture_PlacingModeCenter)
			hlayout:addWidget (avatar)
		end
		vlayout:addItem (hlayout)
	end

	--[[button = ui.TextButton()
	button:setTexture ("ui/btn_orders")
	button:setText ("Offers")
	button:setTextStyle (ui.text_styles.normal_hl.build())
	vlayout:addWidget (button)]]

	--[[local progress = ui.ProgressBar()
	progress:setTextStyle (ui.text_styles.blue_xsmall.build())
	progress:setTexture ("ui/progress_bar_small")
	progress:setText ("2m 4s")
	progress:setValue (0.5)
	vlayout:addWidget (progress)]]
	
	widget:setLayout (vlayout)

	self.widget = widget
	self.tm = 0.0
	return widget
end

function view:update()
	collectgarbage()
end
