require "ui/config.lua"
require "ui/text_styles.lua"

ui.widgets = ui.widgets or { }
ui.widgets.dealer =
{

}

local dealer = ui.widgets.dealer

function dealer.create (id)
	local profile_ptr = underworld2.ProfileDatabase():get (id)
	local profile = profile_ptr:get()
	if not profile then
		return nil
	end

	local button = ui.ContainerButton()
	button:setTag (id)
	button:setTexture ("ui/btn_dealer_long:filtered")
	
	local hlayout = ui.HorizontalLayout()
	hlayout:setItemSpacing (ui.config.hspacing)

	local avatar = ui.AvatarWidget()
	avatar:setAvatarSize (underworld2.Avatar_SizeNormal)
	avatar:setProfile (profile_ptr)
	avatar:setHorizontalSizePolicy (ui.SizePolicyMinimum)
	hlayout:addWidget (avatar)

	--[[local status = ui.Picture()
	status:setHorizontalSizePolicy (ui.SizePolicyMinimum)
	status:setTexture ("ui/ico_offline:filtered")
	hlayout:addWidget (status)]]

	local nickname = ui.TextLabel()
	nickname:setTextStyle (ui.text_styles.dealer_nickname_hl.build())
	nickname:setText (profile:getNickname())
	hlayout:addWidget (nickname)

	button:setHorizontalSizePolicy (ui.SizePolicyFixed)
	button:setSize (0.6, 0.0)

	button:setLayout (hlayout) 

	return button
end 
