require "ui/config.lua"
require "ui/text_styles.lua"

ui.widgets = ui.widgets or { }
ui.widgets.dealer_details =
{

}

local dealer_details = ui.widgets.dealer_details

local function _create_deal_info (type, item_id, amount, when)
	local column0 = ui.TextLabel()
	column0:setTextStyle (ui.text_styles.hint_grey_small.build())
	column0:setText (string.format ("%s %d %s", (type == 0 and "Bought" or "Sold"), amount, underworld2.items[item_id].name))
	column0:setWordWrap (false)
	column0:setHorizontalSizePolicy (ui.SizePolicyMinimum)

	local column1 = ui.TextLabel()
	column1:setTextStyle (ui.text_styles.hint_grey_small.build())
	column1:setText (ui.format.time_passed (underworld2.server_time(), when))
	column1:setWordWrap (false)
	column1:setHorizontalSizePolicy (ui.SizePolicyMinimum)

	local layout = ui.HorizontalLayout()
	layout:addWidget (column0)
	layout:addWidget (ui.Widget())
	layout:addWidget (column1)

	return layout
end

function dealer_details.create (id)
	local profile = underworld2.ProfileDatabase():get (id)

	local widget = ui.Widget()
	local main_layout = ui.VerticalLayout()

	do
		local button_layout = ui.HorizontalLayout()
		do
			local strings = underworld2.StringsDatabase()
			local level = underworld2.LevelsDatabase():get (profile:getLevel())

			local info_layout = ui.VerticalLayout()
			local nickname = ui.TextLabel()
			nickname:setTextStyle (ui.text_styles.dealer_nickname_hl.build())
			nickname:setText (profile:getNickname())
			info_layout:addWidget (nickname)

			local level_layout = ui.HorizontalLayout()
			level_layout:setItemSpacing (ui.config.hspacing)

			local badge = ui.NotificationBadge()
	 		badge:setBadgeTexture ("ui/ico_level:filtered")
	 		badge:setPendingNotifications (profile:getLevel())
	 		badge:setBadgeTextStyle (ui.text_styles.badge.build())
	 		badge:setHorizontalSizePolicy (ui.SizePolicyMinimum)
	 		level_layout:addWidget (badge)

	 		local level_label = ui.TextLabel ()
			level_label:setText (level:get() and strings:get (level:getNameKey()) or "")
			level_label:setTextStyle (ui.text_styles.small_hl.build())
			level_layout:addWidget (level_label)

			info_layout:addItem (level_layout)

			button_layout:addItem (info_layout)
		end

		local arrow = ui.Picture()
		arrow:setTexture ("ui/arrow_action_blue:filtered")
		arrow:setHorizontalSizePolicy (ui.SizePolicyMinimum)
		button_layout:addWidget (arrow)

		local button = ui.ContainerButton()
		button:setTag (id)
		button:setTexture ("ui/btn_dealer_long:filtered")
		button:setLayout (button_layout)
		if profile:isPlayer() then
			events.connect (button:getClickedSignalProxy(), function()
				ui.inbox.show_chat (id)
			end)
		end

		main_layout:addWidget (button)
	end

	local spacer = ui.Widget()
	spacer:setHeight (ui.config.vspacing)
	spacer:setVerticalSizePolicy (ui.SizePolicyFixed)
	main_layout:addWidget (spacer)

	--[[local sep = ui.Picture()
	sep:setTexture ("ui/golden_spacer:filtered")
	local sep_height = sep:getPreferredSize().y
	sep:setVerticalSizePolicy (ui.SizePolicyFixed)
	sep:setPlacingMode (ui.Picture_PlacingModeStretch)
	sep:setSize (1.0, sep_height)
	main_layout:addWidget (sep)

	do
		local bg = ui.Picture()
		bg:setTexture ("ui/modal_illustration_darkening:filtered")
		bg:setPlacingMode (ui.Picture_PlacingModeStretch)
		bg:setBottomMargin (ui.config.vspacing * 0.5)

		local recent_deals_layout = ui.VerticalLayout()
		recent_deals_layout:setItemSpacing (ui.config.vspacing)

		bg:setLayout (recent_deals_layout)
		main_layout:addWidget (bg)
	end

	local sep = ui.Picture()
	sep:setTexture ("ui/golden_spacer:filtered")
	sep:setVerticalSizePolicy (ui.SizePolicyFixed)
	sep:setPlacingMode (ui.Picture_PlacingModeStretch)
	sep:setSize (1.0, sep_height)
	main_layout:addWidget (sep)]]

	widget:setLayout (main_layout)
	local size = widget:getPreferredSize()
	widget:setSize (math.max (0.4, size.x), size.y)
	
	return widget
end 
