require "ui/config.lua"

local button = { }

function button.create (style)
	local widget = ui.ContainerButton()
	widget:setTexture (style.button_texture)
	
	layout = ui.HorizontalLayout()
	layout:setItemSpacing (ui.config.hspacing)

	local fb_icon = ui.Picture()
	fb_icon:setTexture (style.fb_icon_texture)
	layout:addWidget (fb_icon)

	local share_label = ui.TextLabel()
	share_label:setTextStyle (style.text_style.build())
	share_label:setText (style.share_text)
	share_label:setWordWrap (false)
	layout:addWidget (share_label)

	local reward_icon = ui.Picture()
	reward_icon:setTexture (style.reward_icon_texture)
	layout:addWidget (reward_icon)

	local reward_label = ui.TextLabel()
	reward_label:setTextStyle (style.text_style.build())
	reward_label:setText (style.reward_text)
	reward_label:setWordWrap (false)
	layout:addWidget (reward_label)

	widget:setLayout (layout)
	return widget
end

ui.widgets = ui.widgets or { }
ui.widgets.fb_share_button = ui.widgets.fb_share_button or button
