require "ui/core/library.lua"

local lui = ui.core.lib

local wrapper = { }

function wrapper.create (params)
	local obj = setmetatable ({ }, { __index = wrapper })
	
	local icon = lui.picture 
	{ 
		texture = params.icon, 
		hsize_policy = ui.SizePolicyFixed,
		vsize_policy = ui.SizePolicyFixed
	}

	local ribbon = lui.picture
	{
		id = "ribbon",
		texture = params.ribbon,
		hsize_policy = ui.SizePolicyFixed,
		vsize_policy = ui.SizePolicyFixed
	}

	local mod_label = lui.text_label
	{
		id				= "modifier_label",
		text_style 		= params.text_style.build(),
		text 			= "x1.0",
		text_alignment 	= ui.AlignmentHorizontalCenter + ui.AlignmentVerticalCenter,
	}

	local icon_size = icon:getImageSize()
	icon:setSize (icon_size)

	local ribbon_size = ribbon:getImageSize()
	ribbon:setSize (ribbon_size)

	icon:addChild (ribbon)
	ribbon:addChild (mod_label)

	ribbon:setOrigin ((icon_size.x - ribbon_size.x) * 0.5, icon_size.y - ribbon_size.y * 2)
	mod_label:setSize (ribbon_size)

	obj.ui = { icon = icon, mod_label = mod_label, ribbon = ribbon }

	return obj
end

function wrapper:play_activation_animation()
	
end

function wrapper:set_modifier (value)
	self.ui.ribbon:setHidden (value == 1.0)
	self.ui.mod_label:setText (string.format ("x%.1f", value))
end

ui.widgets.stat_boost = wrapper
