require "network/mailto.lua"

local shared = {}

local feedback_body = [[
Please do not remove this system information:
----------------------------------
Device-Type: %s
Device-OS: %s
Build: %i
Player ID: %s
----------------------------------

Tell us how we can help you here. You can also add screenshots or other attachments to the message.
]]

function shared.send_feedback(title)
 	local tag = underworld2.player and tostring(underworld2.player:id()) or "unknown"
 
	local device = os.device:getDeviceIDString() --getDeviceNameString()
	local deviceOS = os.device:getDeviceOSVersionString()
	local build =  VERSION -- getDeviceAppVersionNumber()

	network.mailto {
		to = "support@underworld.zone",
		subject = title or (L("KEY_FB_SHARING_APP_NAME") .. " Feedback"),
		body = string.format (feedback_body, device, deviceOS, build, tag)
	}
end

function shared.show_fb_page()
	os.device:openURL ("http://underworld.zone/fb")
end

underworld2.shared = shared