util = util or { }

local function _check_unique (self, obj)
	assert (self._delegates[obj] == nil)
end

local function _add_delegate (self, obj)
	_check_unique (self, obj)
	self._delegates[obj] = true
end

local function _remove_delegate (self, obj)
	--assert (self._delegates[obj])
	self._delegates[obj] = nil
end

local function _clear_all (self)
	self._delegates = { }
end

local function _notify (self, fn, ...)
	for delegate, value in pairs (self._delegates) do
		local responder = delegate[fn]
		if not responder then
			ErrorPrint ("responder not found")
		end
		if responder then
			responder (delegate, ...)
		end
	end
end

local _mt = {
	add_delegate = _add_delegate,
	remove_delegate = _remove_delegate,
	notify = _notify,
	clear_delegates = _clear_all,
}

function util.delegator (tbl)
	tbl._delegates = { }
	return setmetatable (tbl, { __index = _mt })
end

