util = util or { }

local recursive_lock = { }

function recursive_lock.create (lock_routine, unlock_routine)
	local obj = setmetatable ({ _lock_routine = lock_routine, _unlock_routine = unlock_routine, _locks = 0 }, { __index = recursive_lock })
	return obj
end

function recursive_lock:lock ()
	if self._locks == 0 then
		self._lock_routine()
	end
	self._locks = self._locks + 1
end

function recursive_lock:release()
	self._locks = self._locks - 1
	assert (self._locks >= 0)
	if (self._locks == 0) then
		self._unlock_routine()
	end
end

util.recursive_lock = recursive_lock
